<?php

//-------------------------------------------------------------
//
// $Id: mutant_downloads.php,v 1.6 2004/04/04 08:35:39 kuatodotorg Exp $
//
// STARTED   : 02/04/2004
// COPYRIGHT : 2002-2004 kuato.org
// WWW       : http://www.kuato.org/
// LICENSE   : GPL vs2.0 [ see /docs/COPYING ] 
//
// CREDITS   : All original code
//              
//-------------------------------------------------------------

// Get our module config variables
$limit 		= $mutcfg->get('downloads_limit');
$forum_list = $mutcfg->get('downloads_forum');
$nb_chars 	= $mutcfg->get('downloads_tease_len');

// Assign block title
$template->assign_vars(array(
	'L_MUT_DOWNLOAD_TITLE' 		=> $lang['DOWNLOADS'],
	'L_MUT_TOP_DOWNLOADS'		=> $lang['TOP_DOWNLOADS'],
	'L_MUT_LATEST_DOWNLOADS'	=> $lang['LATEST_DOWNLOADS'],
));

if( empty($forum_list) )
{
    return;
}

// Fetch the posts by order of time(latest posts)
$order_by = " ORDER BY t.topic_time DESC";
$sql_body = '
	SELECT 
		t.topic_title, t.topic_time, 
		f.forum_name, f.forum_id, 
		a.attach_id, a.topic_id, a.topic_id, a.real_filename, a.download_count
	FROM 
		'.TOPICS_TABLE.' t 
	INNER JOIN 
		'.FORUMS_TABLE.' f 
		ON t.forum_id = f.forum_id
	INNER JOIN 
		'.ATTACHMENTS_TABLE.' a 
		ON a.topic_id = t.topic_id 
	WHERE 	t.topic_attachment 	= 1
		AND t.topic_moved_id 	= 0 
		AND t.topic_approved	= 1 
		AND f.forum_id in ('. $forum_list. ')';
$sql = $sql_body .$order_by;
$result = $db->sql_query_limit($sql, $limit, 0);
$row_bydate = $db->sql_fetchrowset($result); 

// Fetch the posts by order of num downloads(top downloads)
$order_by = " ORDER BY a.download_count DESC";
$sql = $sql_body .$order_by;
$result = $db->sql_query_limit($sql, $limit, 0);
$row_byhits = $db->sql_fetchrowset($result); 

// Traverse the arrays and build the table
for( $idx = 0; $idx < count($row_byhits); $idx++ ) 
{
	//
	$file_byhits = $row_byhits[$idx]['real_filename'];
	$url_byhits =  "download.$phpEx$SID&amp;id=". $row_byhits[$idx]['attach_id'];
	$extra_byhits = " (" . $row_byhits[$idx]['download_count'] . ") ";

/*
	if( $user->data['user_id'] != ANONYMOUS )
	{
		// todo: If admin doesn't want anon users to download then don't list
		// url to the file and say so in block
	}
*/
	$template->assign_block_vars("mut_top_dl_row", array(
		'U_MUT_DOWNLOADS_TOP_FILE'     		=> $url_byhits,
		'MUT_DOWNLOADS_TOP_FILE'      		=> $file_byhits,
		'MUT_DOWNLOADS_TOP_EXTRA'      		=> $extra_byhits,
	));
}

for( $idx = 0; $idx < count($row_bydate); $idx++ ) 
{
	//
	$file_bydate = $row_bydate[$idx]['real_filename'];
	$url_bydate =  "download.$phpEx$SID&amp;id=". $row_bydate[$idx]['attach_id'];
	$extra_bydate = " (" . $user->format_date($row_bydate[$idx]['topic_time']) . ") ";

	$template->assign_block_vars("mut_latest_dl_row", array(
		'U_MUT_DOWNLOADS_LATEST_FILE'      	=> $url_bydate,
		'MUT_DOWNLOADS_LATEST_FILE'      	=> $file_bydate,
		'MUT_DOWNLOADS_LATEST_EXTRA'      	=> $extra_bydate,
	));
}
 
?>
