<?php

//-------------------------------------------------------------
//
// $Id: mutant_news.php,v 1.18 2004/04/03 19:04:07 kuatodotorg Exp $
//
// STARTED   : 02/04/2004
// COPYRIGHT : 2002-2004 kuato.org
// WWW       : http://www.kuato.org/
// LICENSE   : GPL vs2.0 [ see /docs/COPYING ] 
//
//-------------------------------------------------------------

if( !defined('IN_PORTAL') )
{
	die("Hacking attempt");
}

// Portal includes
include_once($phpbb_root_path . 'mutant_includes/mutant_functions.'.$phpEx);

// Get our module config variables
$doc_root_id 		= $mutcfg->get('news_root_id'); 
$tease_len 			= $mutcfg->get('news_tease_len');
$news_num_display 	= $mutcfg->get('news_num_display');
$news_num_days 		= $mutcfg->get('news_num_days');
$topic_type 		= $mutcfg->get('news_topic_type');
$post_time_order 	= ($post_order == "asc") ? "ASC" : "DESC";
$start      = request_var('start', 0);
$cid		= request_var('cid', $doc_root_id);
$view		= request_var('view', 'list');
$topic_id	= request_var('t', 0);
$forum_id 	= request_var('f', 0);
$page 		= request_var('page', '');

//
$url_extra = '';
if( !empty($page) )
{
	$url_extra = '&amp;page=' . $_GET['page'];
}

$news_rss_url = '<a href="'. "mutant_net/rss/rss.php?id=". $doc_root_id . '">'. '<img src="mutant_images/xml.gif" alt="rss feed" title="RSS2.0 feed"/>'. '</a>';

// Fill in news specific title
$template->assign_vars(array(
	'L_MUT_NEWS_LATEST_NEWS'	=> $lang['LATEST_NEWS'],
	'L_MUT_NEWS_CAT_TITLE'    	=> $lang['NEWS_CATEGORIES'],
	'L_MUT_NEWS_ARCHIVES'		=> $lang['NEWS_ARCHIVES'],
	'MUT_NEWS_RSS_URL'			=> $news_rss_url
));

// Sanity checks
if( empty( $news_num_display) ) 
{
	$news_num_display = 5;
}
if( empty( $news_num_days) ) 
{
	$news_num_days = 365;
}
$min_topic_time = time() - ($news_num_days * 86400);

// Grab the forum tree 
$forum_tree =& new MutantForumTree($db, $doc_root_id);

// Create a list of the forums based on current news forum id
$forum_list =& $forum_tree->createForumList($doc_root_id, $cid);
if( !$forum_list )
{
	return;
}

// Count of the number of topics in the forum list
$sql = 'SELECT
			COUNT(topic_id) AS total_topics
		FROM 
			'.TOPICS_TABLE.' t 
		WHERE 	t.forum_id IN (' . implode(', ', $forum_list) . ') 
		 	AND t.topic_type in (' . $topic_type . ' ) 
			AND t.topic_moved_id = 0
            AND t.topic_approved = 1 
            AND t.topic_time >= ' .$min_topic_time ;
$result = $db->sql_query($sql);
$totals_row = $db->sql_fetchrow($result);	
$total_topics = $totals_row['total_topics'];

// start with an empty right stack for printing tree in loop below
$right = array();

// Get a reference to our forum tree array
$forum_row =& $forum_tree->getForums();

// Print the news categories -- the root news category and all its children
for( $i = 0; $i < count($forum_row); $i++ ) 
{
	$style ='';
	$marker ='';
	$indent = '';

	// ------ Begin of Compute Indentation -----
	// ------ From Gijs Van Tulder's great article at http://www.sitepoint.com/article/hierarchical-data-database/1 -----
	if( count($right) > 0 ) 
	{
		// check if we should remove a node from the stack
		while( $right[count($right)-1] < $forum_row[$i]['right_id'] ) 
		{
		   array_pop($right);
		}
	}

	$indent = str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',count($right));

	// add this node to the stack
	$right[] = $forum_row[$i]['right_id']; 
	// ------ End of Compute Indentation -----

	if( $forum_row[$i]['forum_id'] == $cid )
	{
		// Highlight the current selection
		$style='style="font-weight:bold; text-decoration:none; color:#FF9900"';
		$marker= '*';
		$page_forum_name = $forum_row[$i]['forum_name']; // need this for later

		//$page_forum_nav = unserialize($forum_row[$i]['forum_parents']); // need this for later

	}

	$cat_url = $indent . '<img src="mutant_images/dir.gif" alt=""/>&nbsp;' . '<a href="'. "$SID&amp;start=0$url_extra&amp;cid=". $forum_row[$i]['forum_id'] . '"' . $style . '>'. $forum_row[$i]['forum_name'] . $marker . '</a>';
	$cat_desc = $indent . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $forum_row[$i]['forum_desc'];

	$template->assign_block_vars("mut_news_catrow", array(
		'NEWS_CATEGORY_URL'	=> $cat_url,
		//'NEWS_TOPIC_COUNT'	=> ($i == 0) ? $total_topics_from_root : $forum_row[$i]['forum_topics'],
		'NEWS_CATEGORY_DESC'=> $cat_desc,
		'NEWS_FORUM_IMG'	=> $forum_row[$i]['forum_image'],
		'NEWS_DESC'			=> $forum_row[$i]['forum_desc'],	
		'NEWS_TOPICS'		=> $total_topics
	));
}

// Print the entire message for this one post
if( $view == 'story' )
{
	if( !$topic_id && !$forum_id )
	{
		trigger_error(NO_TOPIC);
	}

	if( !$auth->acl_get('f_read', $forum_id) )
	{
		if ($user->data['user_id'] != ANONYMOUS)
		{
			trigger_error($user->lang['SORRY_AUTH_READ']);
		}

    	login_box(preg_replace('#.*?([a-z]+?\.' . $phpEx . '.*?)$#i', '\1', htmlspecialchars($_SERVER['REQUEST_URI'])), '', $user->lang['LOGIN_VIEWFORUM']);

	}

	$sql = 'SELECT 
				f.forum_id, f.forum_name, f.forum_image,
				t.topic_id, t.topic_replies, t.topic_views, t.topic_title, 
					t.topic_last_post_id, t.forum_id,
				p.post_time, p.post_text, p.bbcode_uid, p.bbcode_bitfield,
				u.username, u.user_id
			FROM 
				'.FORUMS_TABLE.' f  
			INNER JOIN
				'.TOPICS_TABLE.' t 
				ON f.forum_id = t.forum_id
			INNER JOIN
				'.POSTS_TABLE.' p 
				ON t.topic_first_post_id = p.post_id
			INNER JOIN
				'.USERS_TABLE." u 
				ON p.poster_id = u.user_id
			WHERE 	p.topic_id = t.topic_id 
				AND t.topic_id = $topic_id";
	$result = $db->sql_query($sql);
}
else
{
	// Fetch all the topics that qualify. We also need the forum name
	// and image associated with the topic's forum to display the proper icon	
	$sql = 'SELECT 
				f.forum_id, f.forum_name, f.forum_image,
				t.topic_id, t.topic_replies, t.topic_views, t.topic_title, 
					t.topic_last_post_id, t.forum_id,
				p.post_time, p.post_text, p.bbcode_uid, p.bbcode_bitfield,
				u.username, u.user_id
			FROM 
				'.FORUMS_TABLE.' f  
			INNER JOIN
				'.TOPICS_TABLE.' t 
				ON f.forum_id = t.forum_id
			INNER JOIN
				'.POSTS_TABLE.' p 
				ON t.topic_first_post_id = p.post_id
			INNER JOIN
				'.USERS_TABLE.' u 
				ON p.poster_id = u.user_id
			WHERE 	p.topic_id = t.topic_id 
				AND t.topic_type in (' . $topic_type . ' ) 
				AND t.topic_moved_id = 0
				AND t.topic_approved = 1
				AND t.topic_time >= ' .$min_topic_time . '
				AND t.forum_id IN (' . implode(', ', $forum_list) . ")
			ORDER BY p.post_time $post_time_order";
	$result = $db->sql_query_limit($sql, $news_num_display, $start);
}

// Gather the rows into an array
while( $row = $db->sql_fetchrow($result) )
{
	// grab necessary row data
	$message 	= $row['post_text'];
	$replies 	= $row['topic_replies'];
	$views   	= $row['topic_views'];
	$poster_id 	= $row['user_id'];
	$title     	= $row['topic_title'];
	$bbcode_uid = $row['bbcode_uid']; 
	$bbcode_bitfield	= $row['bbcode_bitfield']; 
	$folder_image = "";

	$poster = ($poster_id == ANONYMOUS) ? $user->lang['GUEST'] : $row['username'];
	$post_date 	= $user->format_date($row['post_time'], 'D M d, Y');
   
	// Process smilies :)
	$message = mutant_decode_message($message, $bbcode_uid, $bbcode_bitfield);
	//print("message= ". htmlspecialchars($message) . "<br>");

	// TODO: if html is enabled $message = html_entity_decode($message);

	$last_post_url = "$SID$url_extra" . "&amp;view=story" . "&amp;f=" . $row['forum_id'] . "&amp;t=". $row['topic_id'];
	$comment_url = "viewtopic.$phpEx$SID&amp;p=" . $row['topic_last_post_id'] . '#' . $row['topic_last_post_id'];

	if( $view != 'story' )
	{
		// Limit message length when not in full view mode,
		//  user can click on it to read the whole thing
		if( strlen($message ) > $tease_len )
		{
			$message = mutant_chop_message($message, $tease_len);
			//print("m= ". htmlspecialchars($message). "<br>");
			$message  .= "...";
			$message  .= "<br /><br />";
			$message  .= '<a href="' . $last_post_url . '">' . "[full story]</a>";
		}
	}

	//$forum_url = "viewforum.$phpEx$SID&amp;f=" .$row['forum_id'];
	$forum_url = "$SID&amp;start=0$url_extra&amp;cid=" .$row['forum_id'];
	$author_url = "memberlist.$phpEx$SID&amp;mode=viewprofile&amp;u=" . $poster_id;

	// Fill in the template row for this message
	$template->assign_block_vars("mut_newsrow", array(
		'NEWS_TITLE'   => $title,
		'NEWS_AUTHOR_URL'  => $author_url,
		'MESSAGE'      => $message, 
		'POST_DATE'    => $post_date,
		'POST_SUBJECT' => $post_subject,
		'POSTER_NAME'  => $poster,
		'POSTER_ID'    => $poster_id, 
		'TOPIC_ID'     => $row['topic_id'], 
		'FORUM_IMG'    => $row['forum_image'],
		'FORUM_URL'    => $forum_url,
		'FORUM_NAME'   => $lang['VIEW_ALL_CATEGORY']. $row['forum_name'],
		'U_URL'        => $last_post_url,
		'REPLIES' 	   => $replies,
		'VIEWS'        => $views,
		'U_COMMENT_URL'  => $comment_url,
		'L_COMMENTS'   => $lang['COMMENTS'],
		'L_AUTHOR'     => $user->lang['AUTHOR'],
		'L_POSTED'     => $user->lang['POSTED'], 
		'L_REPLIES'    => $user->lang['REPLIES'],
		'L_POSTS'      => $user->lang['POSTS'],
		'L_TOPIC_FOLDER_ALT' => $folder_alt
  ));
} // end for

// Fill in the pagenation values and call the phpbb routines to do all the work
$template->assign_vars(array(
	'S_NEWS_VIEW'  => $view,
	'MUT_NEWS_PAGE_NUMBER'   => on_page($total_topics, $mutcfg->get('news_num_display'), $start),
	//'MUT_NEWS_TOTAL_POSTS'  => ($total_topics == 1) ? $lang['NEWS_ITEM'] : sprintf($lang['NEWS_ITEMS'], $total_topics),
	'MUT_NEWS_TOTAL_POSTS'  => ($total_topics == 1) ? $page_forum_name .' -- '. $lang['NEWS_ITEM'] : sprintf("$page_forum_name -- %d Items", $total_topics),
	'MUT_NEWS_PAGINATION'    => generate_pagination("$SID$url_extra&amp;cid=$cid", $total_topics, $mutcfg->get('news_num_display'), $start),
	'MUT_NEWS_NAVLINKS'		=> $page_forum_nav
));

?>
