<?php

//-------------------------------------------------------------
//
// $Id: mutant_online.php,v 1.8 2004/04/05 01:28:14 kuatodotorg Exp $
//
// STARTED   : 02/04/2004
// COPYRIGHT : 2002-2004 kuato.org
// WWW       : http://www.kuato.org/
// LICENSE   : GPL vs2.0 [ see /docs/COPYING ] 
//
// CREDITS   : Though modified much of this is based on phpbb's
//		 	   ucp.php and session.php
//              
//-------------------------------------------------------------

if( !defined('IN_PORTAL') )
{
	die("Hacking attempt");
}

$title  = $lang['ONLINE_USERS'];

$guests_online = 0;
$logged_visible_online = 0;
$logged_hidden_online = 0;
$logged_visible_friends_online = 0;
$logged_hidden_friends_online = 0;
$online_userlist = '';
$friends_online_userlist = '';
  
$total_posts = $config['num_posts'];
$total_topics = $config['num_topics'];
$total_users = $config['num_users'];
$newest_user = $config['newest_username'];
$newest_uid = $config['newest_user_id'];

$prev_user_id = 0;
$prev_user_ip = '';
$prev_session_ip  = "0";

// SQL to get the list of users whose session time is greater than or equal
// to the system session online time
$sql = 'SELECT 
			u.username, u.user_id, u.user_allow_viewonline, u.user_type, 
			s.session_ip, s.session_allow_viewonline
		FROM 
			'.USERS_TABLE.' u
		INNER JOIN 
			'.SESSIONS_TABLE.' s
  			ON u.user_id = s.session_user_id
  		WHERE s.session_time >= '.( time() - ($config['load_online_time']) * 60 ).' 
  		ORDER BY u.username ASC, s.session_ip ASC';
$result = $db->sql_query($sql);

if( !$result )
{
	return;
}

while( $row = $db->sql_fetchrow($result) )
{
	// User is logged in and therefore not a guest
	if( $row['user_id'] != ANONYMOUS )
  	{
  		// Skip multiple sessions for one user
  		if( $row['user_id'] != $prev_user_id )
  		{
			if ($row['user_allow_viewonline'] && $row['session_allow_viewonline'])
			{
				$logged_visible_online++;
			}
			else
			{
				$logged_hidden_online++;
			}
		}
			
		$prev_user_id = $row['user_id'];
	}
	else
	{
		// Skip multiple sessions for one user
		if ($row['session_ip'] != $prev_session_ip)
		{
			$guests_online++;
		}
	}

	$prev_session_ip = $row['session_ip'];
  	$prev_user_id = $row['user_id'];
}
 
$total_online_users = $logged_visible_online + $logged_hidden_online + $guests_online;
$full_list_url = '<a href="viewonline.' ."$phpEx$SID" . '">[view full list]' .'</a>';

// Determine if user is logged in
$s_user_online = ( $user->data['user_id'] != ANONYMOUS ) ? true : false;

if( $s_user_online )
{
	// Now figure out how many friends are online and make a list of them
	$sql = 'SELECT DISTINCT 
				u.user_id, u.username, u.user_colour, u.user_allow_viewonline,
					u.user_type,
				MAX(s.session_time) as online_time, 
				MIN(s.session_allow_viewonline) AS viewonline 
			FROM 
				' . ZEBRA_TABLE . ' z 
			INNER JOIN 
				' . SESSIONS_TABLE . ' s 
				ON s.session_user_id = z.zebra_id
			INNER JOIN
				' . USERS_TABLE . ' u 
				ON s.session_user_id = u.user_id
			WHERE 	z.user_id =  ' . $user->data['user_id'] . ' 
				AND z.friend = 1 
			GROUP BY z.zebra_id';

	$result = $db->sql_query($sql);
	$update_time = $config['load_online_time'] * 60;

	while( $row = $db->sql_fetchrow($result) )
	{
		// If online session time is too old then skip this user
		if( time() - $update_time > $row['online_time'] )
		{
			continue;
		}

		if ($row['user_colour'])
		{
			$row['username'] = '<b style="color:#' . $row['user_colour'] . '">' . $row['username'] . '</b>';
		}

		if ($row['user_allow_viewonline'] && $row['viewonline'])
		{
			$friends_online_link = $row['username'];
			$logged_visible_friends_online++;
		}
		else
		{
			$friends_online_link = $row['username'];
			$friends_online_link = '<i>' . $row['username'] . '</i>';
			$logged_hidden_friends_online++;
		}

		if (($row['user_allow_viewonline'] && $row['viewonline']) || $auth->acl_get('u_viewonline'))
		{
			// TODO: If friend has you on ignore list then don't add
			$friends_online_link = "<a href=\"memberlist.$phpEx$SID&amp;mode=viewprofile&amp;u=" . $row['user_id'] . '">' . $friends_online_link . '</a>';
			$friends_online_userlist .= ($friends_online_userlist != '') ? ', ' . $friends_online_link : $friends_online_link;
		}
	}
	$total_online_friends = $logged_visible_friends_online + $logged_hidden_friends_online;
} // end if( $s_user_online )

// Assign template vars and we are outta here
$template->assign_vars(array(
	'L_MUT_ONLINE_TITLE' 	=> $title,
	'U_VIEWONLINE'        	=> "viewonline.$phpEx",
	'S_USER_ONLINE'			=> $s_user_online,
	'U_VIEW_FRIENDS_ONLINE'	=> "ucp.$phpEx",
	'U_VIEWSTATS'          	=> "todo.$phpEx",
	// Stats
	'L_STATISTICS' 			=> $user->lang['STATISTICS'],
	'L_MUT_TOTAL_MEMBERS'	=> $lang['TOTAL_MEMBERS'],
	'L_MUT_TOTAL_POSTS' 	=> $lang['TOTAL_POSTS'],
	'L_MUT_NEWEST_USER' 	=> $lang['NEWEST_USER'],
	'TOTAL_POSTS'   		=> $total_posts,
	'TOTAL_USERS'   		=> $total_users,
    'NEWEST_USER'   		=> sprintf('%s%s%s', '<a href="' . "memberlist.$phpEx$SID&amp;mode=viewprofile&amp;u=$newest_uid" . '">', $newest_user, '</a>'),
	'RECORD_USERS'  		=> sprintf($user->lang['RECORD_ONLINE_USERS'], $config['record_online_users'], $user->format_date($config['record_online_date'])),
	// Who's online
	'L_MUT_WHO_IS_ONLINE'  	=> $lang['WHO_IS_ONLINE'],
	'L_MUT_MEMBERS'		  	=> $lang['MEMBERS'],
	'L_MUT_HIDDEN'		  	=> $lang['HIDDEN'],
	'L_MUT_GUESTS'		  	=> $lang['GUESTS'],
	'L_MUT_TOTAL_ONLINE'			   => $lang['TOTAL_ONLINE'],
	'MUT_ONLINE_TOTAL' 		 		   => $total_online_users,
	'MUT_ONLINE_TOTAL_MEMBERS' 		   => $logged_visible_online,
	'MUT_ONLINE_TOTAL_MEMBERS_HIDDEN'  => $logged_hidden_online,
	'MUT_ONLINE_TOTAL_GUESTS' 		   => $guests_online,
	// Friends online
	'L_MUT_FRIENDS_ONLINE'			   => $lang['FRIENDS_ONLINE'],
	'L_MUT_FRIENDS'					   => $lang['FRIENDS'],
	'L_MUT_HIDDEN_FRIENDS'			   => $lang['HIDDEN_FRIENDS'],
	'L_MUT_TOTAL_FRIENDS'			   => $lang['TOTAL_FRIENDS'],
	'MUT_ONLINE_TOTAL_VISIBLE_FRIENDS' => $logged_visible_friends_online,
	'MUT_ONLINE_TOTAL_HIDDEN_FRIENDS'  => $logged_hidden_friends_online,
	'MUT_ONLINE_TOTAL_FRIENDS'		   => $total_online_friends,
	'MUT_ONLINE_FRIEND_USERLIST_URL'   => $friends_online_userlist,
	// View list
	'MUT_FULL_LIST_URL'				   => $full_list_url
));

?>
