<?php

//-------------------------------------------------------------
//
// $Id: rss.php,v 1.8 2004/04/04 19:58:46 kuatodotorg Exp $
//
// STARTED		: 02/04/2004
// COPYRIGHT 	: 2002-2004 kuato.org
// WWW			: www.kuato.org
// DESCRIPTION	: An RSS module written for Mutant Portal
//
// CREDITS		: All original code
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation
//
//-------------------------------------------------------------

$title    = $lang['HEADLINE_NEWS'];

// Get our module functions and classes
include_once($module_root_path . 'classes.'.$phpEx);

// Read language files
if ( !file_exists($module_root_path . 'language/' . $config['default_lang'] . '/lang_main.'.$phpEx) )
{
	include($module_root_path . 'language/en/lang_main' . $phpEx);
}   
else    
{                           
	include($module_root_path . 'language/'. $config['default_lang'] .  '/lang_main.'. $phpEx);             
}       

// Note: Make marquee width smaller than the block size else it will print
// beyond the block 
$template->assign_vars(array(
	// TODO: 'MUT_RSS_MARQUEE_WIDTH' => $block_size - 10,
	'MUT_RSS_TITLE'     => $title
) );

// Misc variables
$errno = "";

// Read in the site table
$site_array = array();

$sql = "SELECT * FROM " . MUT_RSS_SITE_TABLE . "
		 WHERE disabled=0 ";

if( !($result = @$db->sql_query($sql)) )
{
	$template->assign_block_vars("mut_rssrow", array(
		'MUT_RSS_URL'      => $lang['RSS_Error_Site_Table_Read']
	));
	
	return;
}

// Put each row into a site object array
while( $row = $db->sql_fetchrow($result) )
{
	// Consturct a new site object using a parser object
	$site_obj =& new KO_RssSite(new KO_RssParse);
	
	// Fill in the database row for this site
	$site_obj->assignRow($row);

	// Fetch xml data from server. If time has been reached save the new xml data
	if ($site_obj->updateCache() == true)
	{
		$site_obj->save();
	}

	// Get a reference to our parser object
	$parser_obj =& $site_obj->getParserObject();

	// Copy site xml data to parser object
	$parser_obj->setXml($site_obj->getXml());

	// Parse the xml data 
	$parser_obj->parseXml();

	$site_array[] = $site_obj;
}

while( list($key, $site_obj) = each($site_array) )
{
	// Fill in sitename for this block of news
	$template->assign_block_vars("mut_rss_sitename", array(
		'MUT_RSS_SITE_NAME'      => $site_obj->sitename
	));

	// Get a reference to our parser object
	$parser_obj =& $site_obj->getParserObject();

	for( $i = 0 ; $i <= ($parser_obj->getItemCount() - 1) ; $i++ )
	{ 
		$content = $parser_obj->getContent('item');
		$title = $content[$i]['title'];

		// Chop titles that exceed tease_len. 
		$tease_len = 30;
		$full_title = "";
		if( strlen($title) > $tease_len )
		{
			$full_title = $title;
			$title = mutant_chop_message($title, $tease_len);
			$title .= "...";
		}

		$link =  $content[$i]['link'];
		$url = "<a href=\"$link\" title=\"$full_title\" >" .$title. '</a>';

		// Fill in template for this row
		$template->assign_block_vars("mut_rss_sitename.mut_rssrow", array(
			'MUT_RSS_URL'      => $url,
			'MUT_RSS_DESC'      => $content[$i]['description'],
			'MUT_RSS_DATE'      => $content[$i]['pubdate']
		));
	}
	
	/* todo
	$template->assign_block_vars("mut_rss_sitename", array(
		'MUT_RSS_NEXT_UPDATEX'      => $updated
	));
	*/
}

?>
